unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label6: TLabel;
    btnStart: TButton;
    txtDelay: TEdit;
    Label1: TLabel;
    txtTimes: TEdit;
    Label2: TLabel;
    mmoResult: TMemo;
    procedure btnStartClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  
var
  Form1: TForm1;
  
implementation

{$R *.DFM}

var
  PerformanceCounterOverhead: TLargeInteger;
  
  { MyDelay1 - use GetTickCount }
procedure MyDelay1(MSecs: DWORD); stdcall;
var
  BeginTime: DWORD;
begin
  BeginTime := GetTickCount;
  repeat
  until GetTickCount - BeginTime >= MSecs;
end;

{ MyDelay2 - use QueryPerformanceCounter }
procedure MyDelay2(MSecs: DWORD); stdcall;
var
  rStart, rEnd, rFreq: TLargeInteger;
begin
  { oWv }
  QueryPerformanceFrequency(rFreq);
  rEnd := Round(MSecs * rFreq / 1000);

  { iJjeo}lpƭ }
  QueryPerformanceCounter(rStart);
  rEnd := rEnd + rStart;

  { Dj }
  repeat
    QueryPerformanceCounter(rFreq); { oثepƭ }
  until rFreq >= rEnd;
end;

{ Calls the performance counter to determine the time overhead }
function CalibratePerformanceCounterOverhead: TLargeInteger;
var
  I           : Integer;
  rStart, rEnd: TLargeInteger;
begin
  QueryPerformanceCounter(rStart);

  for I := 1 to 1000 do
    QueryPerformanceCounter(rEnd);

  { oCIs QueryPerformanceCounter 禡ҪOɶ }
  Result := Round((rEnd - rStart) / 1000);
end;

{ MyDelay3 - use QueryPerformanceCounter with Calibration }
procedure MyDelay3(MSecs: DWORD); stdcall;
var
  rStart, rEnd, rFreq: TLargeInteger;
begin
  { oWv }
  QueryPerformanceFrequency(rFreq);
  rEnd := Round(MSecs * rFreq / 1000);

  { iJjeo}lpƭ }
  QueryPerformanceCounter(rStart);
  rEnd := rEnd + rStart
     - PerformanceCounterOverhead * 2;

  { Dj }
  repeat
    QueryPerformanceCounter(rFreq); { oثepƭ }
  until rFreq >= rEnd;
end;

procedure TForm1.btnStartClick(Sender: TObject);
const
  DescStr: array[1..4] of string =
    ('Win32 API Sleep', 'GetTickCount version',
    'QueryPerformanceCounter version',
    'Calibrated QueryPerformanceCounter version');
var
  TryNo, TryTimes, Delaytime: Integer;                    
  DelayProc                 : procedure (AValue: DWORD); stdcall;
  TestKind                  : Integer;
  rStart, rEnd, rFreq       : TLargeInteger;
  ElapsedTime               : Real;
begin
  { ഫզ, w]Ȭ 100  }
  TryTimes := StrToIntDef(txtTimes.Text, 100);
  txtTimes.Text := IntToStr(TryTimes);

  { ഫɶ, w]Ȭ 100 @ }
  Delaytime := StrToIntDef(txtDelay.Text, 100);
  txtDelay.Text := IntToStr(Delaytime);

//  mmoResult.Lines.Clear;
  
  for TestKind := 1 to 4 do
  begin
    { N DelayProc Vҭnժ禡 }
    case TestKind of
      1: DelayProc := Sleep;
      2: DelayProc := MyDelay1;
      3: DelayProc := MyDelay2;
      4: DelayProc := MyDelay3;
    end;

    { O}lɶ }
    QueryPerformanceCounter(rStart);

    for TryNo := 1 to TryTimes do
      DelayProc(Delaytime);

    { OɶípƩҪOɶ, 쬰@ }
    QueryPerformanceCounter(rEnd);
    QueryPerformanceFrequency(rFreq); { oWv }
    ElapsedTime := (rEnd - rStart) /
      (rFreq / 1000);
    
    mmoResult.Lines.Add(Format('%s'#13#10'Oɶ: %f @'
       + #13#10'~t: %f @'#13#10,[DescStr[TestKind], ElapsedTime,
      ElapsedTime - Delaytime * TryTimes]));
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  I: Integer;
begin
 txtDelay.Text := '1000';

{ mmoResult.Lines.Add('1000');
 txtTimes.Text := '1000';
 btnStartClick(btnStart);}

 txtDelay.Text := '100';
 mmoResult.Lines.Add('100');
 txtTimes.Text := '1000';
 btnStartClick(btnStart);

 txtDelay.Text := '10';
 mmoResult.Lines.Add('10');
 txtTimes.Text := '1000';
 btnStartClick(btnStart);

 txtDelay.Text := '1';
 mmoResult.Lines.Add('1');
 txtTimes.Text := '1000';
 btnStartClick(btnStart);

 mmoResult.Lines.SaveToFile('result.txt');
end;

initialization
  { Calibration for MyDelay3 function }
  PerformanceCounterOverhead := CalibratePerformanceCounterOverhead;
end.

