unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label6: TLabel;
    btnStart: TButton;
    txtDelay: TEdit;
    Label1: TLabel;
    txtTimes: TEdit;
    Label2: TLabel;
    mmoResult: TMemo;
    Button1: TButton;
    procedure btnStartClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
  PerformanceCounterOverhead: TLargeInteger;
  ErrorArray: array[1..4, 1..1000] of Real;
  ErrorIndex: Integer;
  
  { MyDelay1 - use GetTickCount }
procedure MyDelay1(MSecs: Longint); stdcall;
var
  BeginTime: Longint;
begin
  BeginTime := GetTickCount;
  repeat
  until GetTickCount - BeginTime >= MSecs;
end;

{ MyDelay2 - use QueryPerformanceCount }
procedure MyDelay2(MSecs: Longint); stdcall;
var
  rStart, rEnd, rFreq: TLargeInteger;
begin
  { oWv }
  QueryPerformanceFrequency(rFreq);
  rEnd.QuadPart := MSecs * rFreq.QuadPart * 1E-3;

  { iJjeo}lpƭ }
  QueryPerformanceCounter(rStart);
  rEnd.QuadPart := rEnd.QuadPart + rStart.QuadPart;

  { Dj }
  repeat
    QueryPerformanceCounter(rFreq); { oثepƭ }
  until rFreq.QuadPart >= rEnd.QuadPart;
end;

{ Calls the performance counter to determine the time overhead }
function CalibratePerformanceCounterOverhead: TLargeInteger;
var
  I           : Integer;      
  rStart, rEnd: TLargeInteger;
begin
  QueryPerformanceCounter(rStart);
  
  for I := 1 to 1000 do
    QueryPerformanceCounter(rEnd);
  
  { oCIs QueryPerformanceCounter 禡ҪOɶ }
  Result.QuadPart := (rEnd.QuadPart - rStart.QuadPart) / 1000;
end;

{ MyDelay3 - use QueryPerformanceCount with Calibration }
procedure MyDelay3(MSecs: Longint); stdcall;
var
  rStart, rEnd, rFreq: TLargeInteger;
begin
  { oWv }
  QueryPerformanceFrequency(rFreq);
  rEnd.QuadPart := MSecs * rFreq.QuadPart * 1E-3;

  { iJjeo}lpƭ }
  QueryPerformanceCounter(rStart);
  rEnd.QuadPart := rEnd.QuadPart + rStart.QuadPart
     - PerformanceCounterOverhead.QuadPart * 2;

  { Dj }
  repeat
    QueryPerformanceCounter(rFreq); { oثepƭ }
  until rFreq.QuadPart >= rEnd.QuadPart;
end;

procedure TForm1.btnStartClick(Sender: TObject);
const
  DescStr: array[1..4] of string =
    ('Win32 API Sleep', 'GetTickCount version',
    'QueryPerformanceCounter version',
    'Calibrated QueryPerformanceCounter version');
var
  TryNo, TryTimes, Delaytime: Integer;                    
  DelayProc                 : procedure (AValue: Longint); stdcall;
  TestKind                  : Integer;                    
  rStart, rEnd, rFreq       : TLargeInteger;              
  ElapsedTime               : Real;                       
begin
  { ഫզ, w]Ȭ 100  }
  TryTimes := StrToIntDef(txtTimes.Text, 100);
  txtTimes.Text := IntToStr(TryTimes);

  { ഫɶ, w]Ȭ 100 @ }
  Delaytime := StrToIntDef(txtDelay.Text, 100);
  txtDelay.Text := IntToStr(Delaytime);

//  mmoResult.Lines.Clear;

  for TestKind := 1 to 4 do
  begin
    { N DelayProc Vҭnժ禡 }
    case TestKind of
      1: DelayProc := Sleep;
      2: DelayProc := MyDelay1;
      3: DelayProc := MyDelay2;
      4: DelayProc := MyDelay3;
    end;

    { O}lɶ }
    QueryPerformanceCounter(rStart);

    for TryNo := 1 to TryTimes do
      DelayProc(Delaytime);

    { OɶípƩҪOɶ, 쬰@ }
    QueryPerformanceCounter(rEnd);
    QueryPerformanceFrequency(rFreq); { oWv }
    ElapsedTime := (rEnd.QuadPart - rStart.QuadPart) /
      (rFreq.QuadPart / 1000);

    ErrorArray[TestKind, ErrorIndex] := ElapsedTime - Delaytime * TryTimes;
{    mmoResult.Lines.Add(Format('%s'#13#10'Oɶ: %f @'
       + #13#10'~t: %f @'#13#10,[DescStr[TestKind], ElapsedTime,
      ElapsedTime - Delaytime * TryTimes]));
}
  end;
  Inc(ErrorIndex);
  if ErrorIndex > 1000 then errorindex := 1;
end;

procedure TForm1.Button1Click(Sender: TObject);

  procedure AddArray(Count: Integer);
  var
    K, I:Integer;
  begin
    for K := 1 to 4 do
    begin
      for I := 2 to Count do
        ErrorArray[K, 1] := ErrorArray[K, 1] + ErrorArray[K, I];

      ErrorArray[K, 1] := ErrorArray[K, 1] / Count;
    end;

  end;

var
  I: Integer;
begin
(* txtDelay.Text := '1000';
 mmoResult.Lines.Add('1000 @');

 mmoResult.Lines.Add('1000');
 txtTimes.Text := '1000';
 {for I := 1 to 10 do }btnStartClick(btnStart);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('100');
 txtTimes.Text := '100';
 ErrorIndex := 1;
 for I := 1 to 10 do btnStartClick(btnStart);
 AddArray(10);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('10');
 txtTimes.Text := '10';
 ErrorIndex := 1;
 for I := 1 to 100 do btnStartClick(btnStart);
 AddArray(100);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('1');
 txtTimes.Text := '1';
 ErrorIndex := 1;
 for I := 1 to 1000 do btnStartClick(btnStart);
 AddArray(1000);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 txtDelay.Text := '100';
 mmoResult.Lines.Add('100 @');

 mmoResult.Lines.Add('1000');
 txtTimes.Text := '1000';
 {for I := 1 to 10 do }btnStartClick(btnStart);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('100');
 txtTimes.Text := '100';
 ErrorIndex := 1;
 for I := 1 to 10 do btnStartClick(btnStart);
 AddArray(10);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('10');
 txtTimes.Text := '10';
 ErrorIndex := 1;
 for I := 1 to 100 do btnStartClick(btnStart);
 AddArray(100);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('1');
 txtTimes.Text := '1';
 ErrorIndex := 1;
 for I := 1 to 1000 do btnStartClick(btnStart);
 AddArray(1000);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));
*)
 txtDelay.Text := '10';
 mmoResult.Lines.Add('10 @');

 mmoResult.Lines.Add('1000');
 txtTimes.Text := '1000';
 {for I := 1 to 10 do }btnStartClick(btnStart);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('100');
 txtTimes.Text := '100';
 ErrorIndex := 1;
 for I := 1 to 10 do btnStartClick(btnStart);
 AddArray(10);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('10');
 txtTimes.Text := '10';
 ErrorIndex := 1;
 for I := 1 to 100 do btnStartClick(btnStart);
 AddArray(100);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('1');
 txtTimes.Text := '1';
 ErrorIndex := 1;
 for I := 1 to 1000 do btnStartClick(btnStart);
 AddArray(1000);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 txtDelay.Text := '1';
 mmoResult.Lines.Add('1 @');

 mmoResult.Lines.Add('1000');
 txtTimes.Text := '1000';
 {for I := 1 to 10 do }btnStartClick(btnStart);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('100');
 txtTimes.Text := '100';
 ErrorIndex := 1;
 for I := 1 to 10 do btnStartClick(btnStart);
 AddArray(10);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('10');
 txtTimes.Text := '10';
 ErrorIndex := 1;
 for I := 1 to 100 do btnStartClick(btnStart);
 AddArray(100);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.Add('1');
 txtTimes.Text := '1';
 ErrorIndex := 1;
 for I := 1 to 1000 do btnStartClick(btnStart);
 AddArray(1000);
 for I := 1 to 4 do
   mmoResult.Lines.Add(Format('%d %f',[I,ErrorArray[I, 1]]));

 mmoResult.Lines.SaveToFile('allresult2.txt');
end;

initialization
  { Calibration for MyDelay3 function }
  PerformanceCounterOverhead := CalibratePerformanceCounterOverhead;
  ErrorIndex := 1;
end.

