unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, notefrm;

type
  TMainForm = class(TForm)
    btnNewNote: TButton;
    lbxNotes: TListBox;
    procedure btnNewNoteClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure lbxNotesDblClick(Sender: TObject);
  private
    function CreateNewNote: TNoteForm;
    procedure ListNotes;
    
    procedure LoadNotes;
    procedure SaveNotes;
    
    procedure WMNoteChanged(var message: TMessage); message WM_NOTE_CHANGED;
  public
    { Public declarations }
  end;
  
const
  FN_NOTES = 'notes.dat';
  
var
  MainForm: TMainForm;
  
implementation

{$R *.DFM}


procedure TMainForm.btnNewNoteClick(Sender: TObject);
begin
  CreateNewNote;
  
  ListNotes;
end;

function TMainForm.CreateNewNote: TNoteForm;
begin
  // S VCL , Hୱ
  Result := TNoteForm.CreateParented(HWND_DESKTOP);

  // ]wsKȵm
  with Result do
  begin
    Left := Self.Left;
    Top := Self.Top - Height;
    if Top < 0 then
      Top := Self.Top + Self.Height;

    UpdateWindow(Handle); // ߧYø
  end;
end;

procedure TMainForm.ListNotes;
var
  I: Integer;
begin
  with lbxNotes.Items do
  begin
    BeginUpdate;
    Clear;

    for I := 0 to Screen.Formcount - 1 do
      if Screen.Forms[I] <> Self then
        AddObject(Screen.Forms[I].Caption, TObject(Screen.Forms[I]));
    
    EndUpdate;
  end;
end;

procedure TMainForm.LoadNotes;
var
  NewNote: TNoteForm;
begin
  with TFileStream.Create(FN_NOTES, fmOpenRead) do
    try
      while Position < Size do
      begin
        // n streaming, إ߷sKȵ
        NewNote := TNoteForm.CreateNew(nil);
        NewNote.ParentWindow := HWND_DESKTOP;

        ReadComponent(NewNote); // ŪKȵe
      end;
    finally
      Free;
    end;
  
  ListNotes; // sCXثeKȵ                          
end;

procedure TMainForm.SaveNotes;
var
  I: Integer;
begin
  with TFileStream.Create(FN_NOTES, fmCreate or fmOpenWrite) do
    try
      for I := 0 to Screen.FormCount - 1 do // {C@ form
        if Screen.Forms[I] <> Self then // gJD
          WriteComponent(Screen.Forms[I]); // NKȵegJ
    finally
      Free;
    end;
end;

procedure TMainForm.WMNoteChanged(var message: TMessage);
begin
  ListNotes;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveNotes;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
  LoadNotes;
end;

procedure TMainForm.lbxNotesDblClick(Sender: TObject);
begin
  with lbxNotes do
  begin
    if itemindex = -1 then exit;
    
    (Items.objects[itemindex] as TNoteForm).bringtofront;
  end;
end;

initialization
  RegisterClasses([TNoteForm]);
end.

