unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShellAPI, Menus, ExtCtrls, ComCtrls, Registry;

const
  HOOKDESK_DLL      = 'dihook.dll';
  
  ESSAY_FILENAME    = 'essay.txt';            
  
  REGISTRY_KEY      = 'Software\Xshadow\Desktop Illusionist';
  
  SEC_GENERAL       = 'General';              
  
  REG_SHOWWALLPAPER = 'ShowWallPaper';        
  REG_FONT          = 'Font';                 
  REG_SEPCOLOR      = 'Seperator Color';      
  
type
  TMainForm = class(TForm)
    pnlEssay: TPanel;
    mmoEssay: TMemo;
    mnuMain: TMainMenu;
    F1: TMenuItem;
    mnuExit: TMenuItem;
    mnuHide: TMenuItem;
    C1: TMenuItem;
    mnuFont: TMenuItem;
    mnuWrite: TMenuItem;
    N2: TMenuItem;
    dlgFont: TFontDialog;
    dlgSepColor: TColorDialog;
    mnuSeperatorColor: TMenuItem;
    mnuEdit: TMenuItem;
    mnuInsertSeperator: TMenuItem;
    N1: TMenuItem;
    mnuShowDesktopWallPaper: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuWriteClick(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure mnuFontClick(Sender: TObject);
    procedure mnuHideClick(Sender: TObject);
    procedure mnuSeperatorColorClick(Sender: TObject);
    procedure mnuInsertSeperatorClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure mnuShowDesktopWallPaperClick(Sender: TObject);
  private
    procedure ApplyColor;
    procedure ApplyFont;
    procedure ApplyEssay;
    
    procedure WMSysCommand(var message: TWMSysCommand); message WM_SYSCOMMAND;
  public
  end;
  
var
  MainForm: TMainForm;
  
procedure SetMainWindow(Wnd: HWND); stdcall;
function SetDeskHook(Wnd: HWND): Boolean; stdcall;

procedure SetShowDesktopWallPaper(Value: Boolean); stdcall;
procedure SetEssay(index: Integer; Str: PChar); stdcall;
procedure SetEssayCount(Count: Integer); stdcall;
procedure SetEssayFont(LF: PLogFont); stdcall;
procedure SetEssayColor(SepColor, TextColor: COLORREF); stdcall;

implementation

uses xDesktop, xFonts;

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  // Y Active Desktop Ұʤ, h{
  if GetActiveDesktopWindow <> 0 then
  begin
    ShowMessage('This program will not function whenever Active Desktop exists');
    Application.Terminate; // {
    Exit;
  end;
  
  // ]wε{
  SetMainWindow(Handle);
  
  // I]w hook, P subclass ӵΨ
  if not SetDeskHook(GetDesktopListView) then
  begin
    ShowMessage('Hook failed');
    Application.Terminate; // {
    Exit;
  end;
  
  // qtεnŪrΤΤjuC
  with TRegIniFile.Create(REGISTRY_KEY) do
    try
      mnuShowDesktopWallPaper.Checked := ReadBool(SEC_GENERAL, REG_SHOWWALLPAPER, True);
      StringToFont(ReadString(SEC_GENERAL, REG_FONT, '"sө", 11, [], [clWhite]'), dlgFont.Font);
      dlgSepColor.Color := StringToColor(ReadString(SEC_GENERAL, REG_SEPCOLOR, 'clLime'));
    finally
      Free;
    end;
  
  // Ju
  mmoEssay.Lines.LoadFromFile(ESSAY_FILENAME);
  
  // ]wܮ६
  SetShowDesktopWallPaper(mnuShowDesktopWallPaper.Checked);
  
  // ]wuܰѼ
  ApplyColor;
  ApplyFont;
  ApplyEssay;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  // xsu
  mmoEssay.Lines.SaveToFile(ESSAY_FILENAME);
  
  // xsuܰѼ  
  with TRegIniFile.Create(REGISTRY_KEY) do
    try
      WriteBool(SEC_GENERAL, REG_SHOWWALLPAPER, mnuShowDesktopWallPaper.Checked);
      WriteString(SEC_GENERAL, REG_FONT, FontToString(dlgFont.Font));
      WriteString(SEC_GENERAL, REG_SEPCOLOR, ColorToString(dlgSepColor.Color));
    finally
      Free;
    end;
  
  // Ѱ hook
  SetDeskHook(0);
end;

procedure TMainForm.mnuWriteClick(Sender: TObject);
begin
  ApplyEssay;
end;

procedure TMainForm.mnuExitClick(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.mnuSeperatorColorClick(Sender: TObject);
begin
  if dlgSepColor.Execute then
    ApplyColor;
end;

procedure TMainForm.mnuFontClick(Sender: TObject);
begin
  if dlgFont.Execute then
    ApplyFont;
end;

procedure TMainForm.mnuHideClick(Sender: TObject);
begin
  // ëe]wu
  ApplyEssay;
  
  ShowWindow(Handle, SW_HIDE);
end;

procedure TMainForm.ApplyColor;
begin
  // ]wuC
  SetEssayColor(dlgSepColor.Color, dlgFont.Font.Color);
end;

procedure TMainForm.ApplyEssay;
var
  I: Integer;
begin
  // Nu]w DLL
  with mmoEssay do
  begin
    for I := 0 to Lines.Count - 1 do
      SetEssay(I, PChar(Lines[I]));
    
    SetEssayCount(Lines.Count);
  end;
end;

procedure TMainForm.ApplyFont;
var
  LF: TLogFont;
begin
  // ]wur, Pɳ]wC
  GetObject(dlgFont.Font.Handle, SizeOf(TLogFont), @LF);
  SetEssayFont(@LF);
  ApplyColor;
end;

procedure TMainForm.mnuInsertSeperatorClick(Sender: TObject);
begin
  mmoEssay.Lines.Add('-');
end;

procedure TMainForm.WMSysCommand(var message: TWMSysCommand);
begin
  // UsΥѨtο, uNð_
  case message.CmdType of
    SC_CLOSE: ShowWindow(Handle, SW_HIDE);
  else inherited;
  end
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  ShowWindow(Application.Handle, SW_HIDE);
end;

procedure TMainForm.mnuShowDesktopWallPaperClick(Sender: TObject);
begin
  // O_ܮ६
  mnuShowDesktopWallPaper.Checked := not mnuShowDesktopWallPaper.Checked;
  SetShowDesktopWallPaper(mnuShowDesktopWallPaper.Checked);
end;

procedure SetMainWindow; external HOOKDESK_DLL;
  function SetDeskHook; external HOOKDESK_DLL;
    
    procedure SetShowDesktopWallPaper; external HOOKDESK_DLL;
      procedure SetEssay; external HOOKDESK_DLL;
        procedure SetEssayCount; external HOOKDESK_DLL;
          procedure SetEssayFont; external HOOKDESK_DLL;
            procedure SetEssayColor; external HOOKDESK_DLL;
              
            end.

