unit drawthrd;

interface

uses
  Classes, Windows, Forms, SysUtils, Graphics, Registry, Math;

type
  TDrawThread = class(TThread)
  private
    FWnd: HWND; // ùO@B@

    FCurEssayFile: string; // ثeuɦW
    FEssay: TStringList; // ثeu夺e

    FWindowWidth, FWindowHeight, FWindowMiddleY: Integer;
    FWindowRect: TRect; // xΰϰ

    FMoveSpeed: Integer; // ʳt
    FDelayTime, FClearDelayTime, FChangeDelayTime: Integer;

    procedure ChooseAndLoadEssay; // ܨøJ@gu
    procedure DisplayEssay;  // ثeu
  protected
    procedure Execute; override;
  public
    constructor Create(AHWnd: HWND);
    destructor Destroy; override;
  end;

implementation

uses util, xFonts;

{ TDrawThread }

procedure TDrawThread.ChooseAndLoadEssay;
var
  Files: TStrings;
  index: Integer;
begin
  Files := TStringList.Create;
  try
    with TRegIniFile.Create(REGISTRY_KEY) do
      try
        ReadSection(SEC_ESSAYFILES, Files);
      finally
        Free;
      end;
    
    if Files.Count = 0 then // S]wu
    begin
      FEssay.Clear;
      FEssay.Add('S]wu');
      Exit;
    end;
    
    if Files.Count = 1 then // u@Ӫ, So
      FCurEssayFile := Files[0]
    else
    begin
      repeat // Hüƿܤ@ӻPثePu
        index := Random(Files.Count);
      until Files[index] <> FCurEssayFile;
      
      FCurEssayFile := Files[index];
    end;
    
    // Ju
    try
      FEssay.LoadFromFile(FCurEssayFile);
    except
      FEssay.Add('LkJɮ ' + FCurEssayFile);
    end;
  finally
    Files.Free;
  end;
end;

constructor TDrawThread.Create(AHWnd: HWND);
begin
  inherited Create(False);

  FreeOnTerminate := True;
  
  FWnd := AHWnd;
  
  FEssay := TStringList.Create;
  
  with TRegIniFile.Create(REGISTRY_KEY) do
    try
      FMoveSpeed := ReadInteger(SEC_GENERAL, REG_MOVESPEED, 5);
      FDelayTime := ReadInteger(SEC_GENERAL, REG_MOVEDELAYTIME, 10);
      FClearDelayTime := ReadInteger(SEC_GENERAL, REG_CLEARDELAYTIME, 10);
      FChangeDelayTime := ReadInteger(SEC_GENERAL, REG_CHANGEDELAYTIME, 5000);
    finally
      Free;
    end;

  GetClientRect(FWnd, FWindowRect);
  FWindowWidth := FWindowRect.Right;
  FWindowHeight := FWindowRect.Bottom;
  FWindowMiddleY := FWindowHeight div 2;
end;

destructor TDrawThread.Destroy;
begin
  FEssay.Free;
  
  inherited Destroy;
end;

procedure TDrawThread.Execute;
begin
  repeat
    ChooseAndLoadEssay; // ܨøJ@gu
    DisplayEssay; // ثeu
  until Terminated;
end;

procedure TDrawThread.DisplayEssay;
var
  X, Y, OldY           : Integer;
  R                    : TRect;
  LineIndex, LineHeight: Integer;
  TopMost, BottomMost  : Integer;

  ScrollFinalY         : Integer;
  TextMetric           : TTextMetric;
begin
  with TCanvas.Create do
    try
      Handle := GetDC(FWnd);

      // ]wr, Cⵥ
      with TRegIniFile.Create(REGISTRY_KEY) do
        try
          StringToFont(ReadString(SEC_GENERAL, REG_DISPLAYFONT, DEFAULT_DISPLAYFONT), Font);
        finally
          Free;
        end;

      // ӵYprβʳt
      if FWindowHeight <> Screen.Height then
      begin
        Font.Size := Max((FWindowHeight * Font.Size) div Screen.Height, 1);
        FMoveSpeed := Max((FWindowHeight * FMoveSpeed) div Screen.Height, 1);
      end;

      // m
      SetTextAlign(Handle, TA_CENTER);
      // o氪
      GetTextMetrics(Handle, TextMetric);
      LineHeight := (TextMetric.tmHeight + TextMetric.tmExternalLeading) * 3 div 2;

      Brush.Style := bsSolid;
      Brush.Color := clBlack;
      
      R := FWindowRect;
      FWindowRect.Top := LineHeight;
      
      TopMost := LineHeight; // r̰I
      BottomMost := FWindowHeight - LineHeight * 2; // ŗCI
      
      LineIndex := 0; // qĹs}l
      repeat
        // q̤U]W
        Y := FWindowHeight;
        OldY := Y;
        
        R.Top := R.Bottom; // Ĥ@MFF
        
        // FTme (YWثe̩UCre)
        repeat
          FillRect(R); // MӪr
          TextOut(FWindowWidth div 2, Y, FEssay[LineIndex]);
          
          R.Top := Y;
          R.Bottom := OldY + LineHeight;
          OldY := Y; // s OldY
          
          Dec(Y, FMoveSpeed);
          
          // ץ Y , Y֭nIW@F, h Y Tw
          if Y - BottomMost < FMoveSpeed then
            Y := BottomMost;
          
          if FDelayTime <> 0 then Sleep(FDelayTime); // 
        until (Y = BottomMost) or Terminated;
        
        if Terminated then Break;
        
        // H̷s Y , Ae@
        FillRect(R); // MӪr
        TextOut(FWindowWidth div 2, Y, FEssay[LineIndex]);

        // pʳWy
        if TopMost > LineHeight then
          R.Top := TopMost
        else
          R.Top := TopMost + LineHeight; // 묹@

        R.Bottom := BottomMost + LineHeight; // ثeUt
        ScrollFinalY := R.Top - LineHeight; // ʳ̲צm
        
        // eWҦr̤r`it׽wwWʤ@
        while (R.Top > ScrollFinalY) and not Terminated do
        begin
          ScrollWindow(FWnd, 0, -FMoveSpeed, @R, @FWindowRect);
          Dec(R.Top, FMoveSpeed);
          Dec(R.Bottom, FMoveSpeed);
          if FDelayTime <> 0 then Sleep(FDelayTime);
        end;

        // srm
        TopMost := R.Top;
        BottomMost := R.Bottom;
        
        Inc(LineIndex);
      until (LineIndex >= FEssay.Count) or Terminated;

      // L𮧮ɶ
      if FChangeDelayTime <> 0 then Sleep(FChangeDelayTime);

      // ѥ~Ӥ, NeWҦFFM
      for X := 0 to FWindowWidth div 2 do
      begin
        if Terminated then Exit;

        MoveTo(X, 0);
        LineTo(X, FWindowHeight);
        MoveTo(FWindowWidth - X, 0);
        LineTo(FWindowWidth - X, FWindowHeight);

        if FClearDelayTime <> 0 then Sleep(FClearDelayTime);
      end;
    finally
      Free;
    end;
end;

initialization
  Randomize;
end.

