unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, DrawThrd;

type
  TMainForm = class(TForm)
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
  private
    FDrawThread: TDrawThread;
    
    procedure WMSysCommand(var message: TWMSysCommand); message WM_SYSCOMMAND;
    procedure WMActivate(var message: TWMActivate); message WM_ACTIVATE;
    procedure WMNCActivate(var message: TWMNCActivate); message WM_NCACTIVATE;
    procedure WMActivateApp(var message: TWMActivateApp); message WM_ACTIVATEAPP;
  public
    
  end;
  
var
  MainForm: TMainForm;
  
implementation

uses util;

{$R *.DFM}

procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
    Shift: TShiftState);
begin
  Close;
end;

procedure TMainForm.FormMouseDown(Sender: TObject; Button: TMouseButton;
    Shift: TShiftState; X, Y: Integer);
begin
  Close;
end;

procedure TMainForm.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
    Y: Integer);
const
  OrgX: Integer = -1;
  OrgY: Integer = -1;
begin
  if (OrgX = -1) then
  begin
    OrgX := X;
    OrgY := Y;
  end else
    if (OrgX <> X) or (OrgY <> Y) then Close;
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
  ShowCursor(False); // Nƹð_

  FDrawThread := TDrawThread.Create(Handle); // إ֤߮߰
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FDrawThread.Terminate; // ֤߰
end;

procedure TMainForm.WMActivate(var message: TWMActivate);
begin
  if message.Active = WA_INACTIVE then
    Close
  else
    inherited;
end;

procedure TMainForm.WMNCActivate(var message: TWMNCActivate);
begin
  if message.Active = False then
    Close
  else
    inherited;
end;

procedure TMainForm.WMActivateApp(var message: TWMActivateApp);
begin
  if message.Active = False then
    Close
  else
    inherited;
end;

procedure TMainForm.WMSysCommand(var message: TWMSysCommand);
begin
  if message.CmdType and $FFF0 = SC_SCREENSAVE then
    message.Result := 0
  else
    inherited;
end;

end.

