unit util;

interface

uses Windows, Classes, SysUtils, Graphics, Forms, ComCtrls, Messages, Math;

const
  // aϤlt
  TILE_WIDTH                = 32;                       // ϤeI
  TILE_HEIGHT               = 32;                       // ϤI
  
  SM_TILE_WIDTH             = TILE_WIDTH div 4;         // pHeI
  SM_TILE_HEIGHT            = TILE_HEIGHT div 4;        // pHI
  
  TILE_NUM_X                = 13;                       // eb
  TILE_NUM_Y                = 13;                       // eab
  
  WORLD_WIDTH               = TILE_WIDTH * TILE_NUM_X;  // ee
  WORLD_HEIGHT              = TILE_HEIGHT * TILE_NUM_Y; // e
  
  SIG_MYFILE                = 'Xshadow_Stock';          // ϮwΦaɮתY
  
  FN_TILE_ARCHIVE           = 'TILES.TIA';              // Ϯwɮ
  
  FN_MAP_PREFIX             = 'MAP';                    // dɦW (MAP??.DAT)
  FN_MAP_EXT                = '.DAT';                   // dɰɦW
  
  LAYER_TERR                = 0;                        // aμh
  LAYER_TERRITEM            = 1;                        // aΪh
  LAYER_ITEM                = 2;                        // ~h
  LAYER_HITERRITEM          = 3;                        // aΪh
  
  LAYER_MAX                 = 3;                        // ̦h찪aΪh
  
  // lt
  DR_IMAGES                 = 'img\';                   // vɪsؿ
  
  SPRITE_DEFAULT_SPEED      = 4;                        // ⪺w]t
  SMOOTH_MOVE_THRESHOLD     =
    SPRITE_DEFAULT_SPEED * 3 - 1;                       // Ʋʪe                        
  
  MYTANK_DEFAULT_SPEED      = 5;                        // ڤZJw]t
  BULLET_DEFAULT_SPEED      = 10;                       // luw]t
  BULLET_DEFAULT_BLOW_RANGE = 3;                        // luw]zd
  
  MAX_ETANK_PER_SCENARIO    = 20;                       // CDdĤZJƥ
  MAX_TANK_ON_SCREEN        = 5;                        // eW̦hZJƥ
  MAX_ETANK_COLLISION_COUNT = 5;                        // ĤZJsIƤW
  
  PROBAB_ETANK_SHOT_BULLET  = 0.1;                      // ĤZJgluv
  PROBAB_ETANK_RANDOM_TURN  = 0.02;                     // ĤZJHNsv
  PROBAB_ETANK_BORN         = 0.02;                     // ĤZJX;v
  PROBAB_GEM_BORN           = 0.005;                    // _X{v
  
  TIMER_ID_GEM              = 1;                        // _ͷҨϥΪ Timer s
  TIMER_ID_GEM_CLOCK        = 2;                        // _ĪGҨϥΪ Timer s
  TIMER_ID_GEM_HAT          = 3;                        // Ul_ĪGҨϥΪ Timer s
  TIMER_ID_GEM_ARROW        = 4;                        // }b_ĪGҨϥΪ Timer s
  
  // ǻCDj骺Ts
  WM_DESTROY_OBJECT         = WM_USER + 0;              // RO
  WM_GAMEOVER               = WM_USER + 1;              // CT
  WM_SPECIAL_CONDITION      = WM_USER + 2;              // Y_ɲͮĪGO
  WM_INIT_LEVEL             = WM_USER + 3;              // ds}l
  
var
  // `ƪܼ, b̤U誺 initialization Bl  
  TILE_RECT        : TRect;                          
  TRANSPARENT_COLOR: TColor;                         
  
  // g`p⪺k, ҥHت => dk
  TILEWIDTH        : array[0..TILE_NUM_X] of Integer;
  TILEHEIGHT       : array[0..TILE_NUM_Y] of Integer;
  
procedure CheckSignature(fs: TFileStream; const Sig: string);

implementation

procedure CheckSignature(fs: TFileStream; const Sig: string);
var
  S: string;
begin
  SetLength(S, Length(Sig));
  fs.read (S[1], Length(Sig));
  if CompareText(S, Sig) <> 0 then
    raise Exception.Create('File signature not match');
end;

var
  I: Integer;
initialization
  TILE_RECT := Classes.Rect(0, 0, TILE_WIDTH, TILE_HEIGHT);
  TRANSPARENT_COLOR := RGB(0, 0, 0);
  
  for I := 0 to TILE_NUM_X do
    TILEWIDTH[I] := I * TILE_WIDTH;
  
  for I := 0 to TILE_NUM_Y do
    TILEHEIGHT[I] := I * TILE_HEIGHT;
  
finalization
end.

