unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellAPI;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Memo1: TMemo;
    Button1: TButton;
    procedure MailToURLClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
  
var
  Form1: TForm1;

implementation

{$R *.DFM}

function Execute(const Command: string; bWaitExecute: Boolean; bShowWindow: Boolean; PI: PProcessInformation): Boolean;
var
  StartupInfo       : TStartupInfo;
  ProcessInformation: TProcessInformation;
begin
  FillChar(StartupInfo, SizeOf(TStartupInfo), 0);
  with StartupInfo do
  begin
    cb := SizeOf(TStartupInfo);
    dwFlags := STARTF_USESHOWWINDOW;
    if bShowWindow then
      wShowWindow := SW_NORMAL
    else
      wShowWindow := SW_HIDE;
  end;

  Result := CreateProcess(nil, PChar(Command),
    nil, nil, True, NORMAL_PRIORITY_CLASS, nil, nil,
    StartupInfo, ProcessInformation);

  if not Result then Exit;

  if bWaitExecute then
    WaitForSingleObject(ProcessInformation.hProcess, INFINITE);

  if Assigned(PI) then
    Move(ProcessInformation, PI^, SizeOf(ProcessInformation));
end;

procedure TForm1.MailToURLClick(Sender: TObject);
const
  URLs: array[0..4] of string  =
    ('mailto:kuan@vclxx.com',
    'mailto:kuan@vclxx.com?to=Xshadow@cs.nthu.edu.tw&to=MichaelJordan@NBA.com',
    'mailto:kuan@vclxx.com?subject=Hello&body=RUNPC%20Sample',
    'mailto:kuan@vclxx.com?cc=Xshadow@cs.nthu.edu.tw&subject=Test',
    'mailto:kuan@vclxx.com?body=');
var
  S: string;
begin
  S := URLs[(Sender as TLabel).Tag];
  if (Sender as TLabel).Tag = 4 then
    S := S + Memo1.Lines.Text;

  Execute('h:\winapp\eudora\eudora.exe /m ' + S, false, true, nil);
//  ShellExecute(Handle, 'open', PChar(S), nil, nil, SW_SHOW);
end;


end.

